// Class object for the map window  -*-C++-*-

#ifndef INC_MAP
#define INC_MAP

// Public include files
#include <X11/Intrinsic.h>
#include <X11/xpm.h>


// define's
#define ITEM_WIDTH	32
#define ITEM_HEIGHT	24
#define MAP_WIDTH	(20 * ITEM_WIDTH)
#define MAP_HEIGHT	(20 * ITEM_HEIGHT)

// These defines are icon indexes
#define IHERO	0
#define IBANK	1
#define ITREASURE 2
#define ICOMPANION 3
#define IFINISH 4
#define IROAD	5
#define ISEA	6
#define ISUPPLIES 7
#define IFOREST 8
#define IWALL_E 9
#define IWALL_N 10
#define IWALL_S 11
#define IWALL_W 12
#define N_ICONS 13


class MapWindow {
public:
  MapWindow (Display *, Window parent);
			// Create the map window
  ~MapWindow ();

  void show (void);	// Map the map window
  void hide (void);	// Unmap the windows
  void redraw (void);	// Draw the entire window
  void redraw_area (Window W, int x, int y,
		    int w, int h); // Redraw part of the window
  void update (void);	// Redraw part of the map when the player moves
  void clean (void);	// Send an expose event to the entire map window
  void get_offset (XButtonEvent *, int *, int *);

private:
  Display *display;
  Window map_window, hero_subwindow;
  GC gc;
  XColor bgcolor;
  XpmAttributes xpmattr;
  // Color pixmaps which store pieces of the map
  struct {
    Pixmap pix, mask;
  } icon[N_ICONS];
};

extern MapWindow *map_window;


// Forward declarations
void update_map (void);		// Redraw a location in the map window
void redraw_map (void);		// Redraw all of the map window


#endif
