// Class object for transient message window  -*-C++-*-

#ifndef INC_TRANSIENT
#define INC_TRANSIENT

// Public include files
#include <X11/Intrinsic.h>


class TransientMessages {
public:
  TransientMessages (Display *, Window parent);
			// Create the window our messages will be in
  ~TransientMessages ();

  void popup (void);	// Display the message window
  void hide (void);	// Hide the message window
  void print (int, const char *); // Add a line of text to the message window
  // The first parameter specifies how to show the new message:
#define TM_CLEAR 1	// Clear all previous messages
#define TM_ADD 2	// Add this message underneath previous messages
#define TM_REPLACE 3	// Replace the last message with this one

  void redraw (void);	// Draw the window in response to an expose event

  Boolean mapped;

private:
  Display *display;
  Window window;
  GC gc;
  XFontStruct *font;
  unsigned int winwidth, winheight;

  int num_messages;
  char *message[3];
  int msglen[3], linewidth[3];
};

extern TransientMessages *transient;


#endif
